
# global unique flow id for each (Agent_pair $pid, TCP_pair $cid), also pass to $tcps (0,1,...,$pid*$cid-1)
set fid_ 0

# counter for flow generated and finished
set flow_gen 0
set flow_fin 0

# counter for task generated and finished
set task_gen 0
set task_fin 0

source "common.tcp.tcl"
source "common.agent.tcl"
# source "common.task.tcl"

#####################################################################
# CLASS RELATION
#####################################################################
#
# Agent_pair setup{}/check_if_behind{} ==> TCP_pair setup{}/setpid{}/setconnid{}/setfid{}
# Agent_pair init_schedule{}/check_if_behind{} ==> TCP_pair set_callback{}
# Agent_pair schedule{} ==> TCP_pair start{}
#
# TCP_pair start_notify{} ==> Agent_pair start_notify{}
# TCP_pair fin_notify{} ==> Agent_pair fin_notify{}
#
#####################################################################

#####################################################################
#
# function call procedure:
#   advance-bytes ->
#   advance_bytes -> send_much -> foutput:send -> sendpacket(set_prio) -> send
#   foutput[receive ack] -> bufferempty ->
#   done_data -> TCP_pair.fin_notify -> Agent_pair.fin_notify
#
#####################################################################
