#dctcp

#:::::::::::::::: Queue/ :::::::::::::::: 

set var(switch_alg) "RED"
set var(queue_size) 1000

#:::::::::::::::: Agent/TCP/ ::::::::::::::::

Agent/TCP set window_ 1256 		; # 20 receiver window

# congestion
Agent/TCP set windowInit_ 5 	; # init cwnd
Agent/TCP set windowOption_ 0 	; # cwnd increase pattern after ssthresh. 0: linear 1: standard

# retransmission
Agent/TCP set minrto_ 0.2		; # 
Agent/TCP set tcpTick_ 0.01 	; # clock granularity

# DCTCP
Agent/TCP set ecn_ 1
Agent/TCP set old_ecn_ 1
Agent/TCP set slow_start_restart_ false

Agent/TCP set dctcp_ true
Agent/TCP set dctcp_g_ 0.0625;

Agent/TCP/FullTcp set spa_thresh_ 3000 	; # 0:disable, rcv_nxt < spa_thresh? -> 1 seg per ack
Agent/TCP/FullTcp set interval_ 0.04 	; # 0.1 delayed ACK interval

#---------------- pFabric Settings ----------------

Agent/TCP set window_ 1000000 	; # 20 receiver window

# congestion
Agent/TCP set windowInit_ 12 	; # 2 initial congestion window cwnd
if { $var(queue_size) > 12 } {
   Agent/TCP set maxcwnd_ [expr $var(queue_size) - 1]
} else {
   Agent/TCP set maxcwnd_ 12
} 								; # 0: unlimit
Agent/TCP set windowOption_ 0 	; # cwnd increase pattern after ssthresh. 0: linear 1: standard

# retransmission
Agent/TCP set minrto_ 0.00045 	; # 0.2 minimum retransmission timeout, proportional to queue size difference
Agent/TCP set maxrto_ 2 		; # 60 maximum retransmission timeout
Agent/TCP set rtxcur_init_ 0.00045  ; # 3.0 initial value for current retransmit value
Agent/TCP set tcpTick_ 0.000001 	; # 0.01 clock granularity

# DCTCP
Agent/TCP set slow_start_restart_ true
Agent/TCP/FullTcp set spa_thresh_ 0 		; # 0:disable, rcv_nxt < spa_thresh? -> 1 seg per ack
Agent/TCP/FullTcp set interval_ 0.000006 	; # 0.1 delayed ACK interval

#---------------- pFabric Settings ----------------

set myAgent "Agent/TCP/FullTcp/Sack";

#:::::::::::::::: Queue/ ::::::::::::::::

Queue set limit_ $var(queue_size)

# DCTCP
Queue/RED set bytes_ false
Queue/RED set setbit_ true
Queue/RED set gentle_ false
Queue/RED set q_weight_ 1.0
Queue/RED set mark_p_ 1.0
Queue/RED set thresh_ 6500
Queue/RED set maxthresh_ 6500
			 
DelayLink set avoidReordering_ true

#:::::::::::::::: Other ::::::::::::::::


